// Generated by gencpp from file ld_msgs/EgoLineIndex.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_EGOLINEINDEX_H
#define LD_MSGS_MESSAGE_EGOLINEINDEX_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct EgoLineIndex_
{
  typedef EgoLineIndex_<ContainerAllocator> Type;

  EgoLineIndex_()
    : header()
    , max_power_polynomial(0)
    , window_size(0)
    , is_ws_forward(false)
    , a(0.0)
    , b(0.0)
    , c(0.0)
    , d(0.0)
    , e(0.0)
    , f(0.0)
    , max_residual(0.0)  {
    }
  EgoLineIndex_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , max_power_polynomial(0)
    , window_size(0)
    , is_ws_forward(false)
    , a(0.0)
    , b(0.0)
    , c(0.0)
    , d(0.0)
    , e(0.0)
    , f(0.0)
    , max_residual(0.0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef int32_t _max_power_polynomial_type;
  _max_power_polynomial_type max_power_polynomial;

   typedef int32_t _window_size_type;
  _window_size_type window_size;

   typedef uint8_t _is_ws_forward_type;
  _is_ws_forward_type is_ws_forward;

   typedef float _a_type;
  _a_type a;

   typedef float _b_type;
  _b_type b;

   typedef float _c_type;
  _c_type c;

   typedef float _d_type;
  _d_type d;

   typedef float _e_type;
  _e_type e;

   typedef float _f_type;
  _f_type f;

   typedef float _max_residual_type;
  _max_residual_type max_residual;





  typedef boost::shared_ptr< ::ld_msgs::EgoLineIndex_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::EgoLineIndex_<ContainerAllocator> const> ConstPtr;

}; // struct EgoLineIndex_

typedef ::ld_msgs::EgoLineIndex_<std::allocator<void> > EgoLineIndex;

typedef boost::shared_ptr< ::ld_msgs::EgoLineIndex > EgoLineIndexPtr;
typedef boost::shared_ptr< ::ld_msgs::EgoLineIndex const> EgoLineIndexConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::EgoLineIndex_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/lddev001/catkin_ws/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::EgoLineIndex_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::EgoLineIndex_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::EgoLineIndex_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5df6c197a40ff8c7e32dbaebe490f7d2";
  }

  static const char* value(const ::ld_msgs::EgoLineIndex_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5df6c197a40ff8c7ULL;
  static const uint64_t static_value2 = 0xe32dbaebe490f7d2ULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/EgoLineIndex";
  }

  static const char* value(const ::ld_msgs::EgoLineIndex_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
int32 max_power_polynomial\n\
int32 window_size    # the number of frames that use to do the fitting\n\
bool is_ws_forward   # if the frame number now is n, bool is_ws_forward= true ,means use frames[n,n+ws],else use frames[n-ws,n]\n\
float32 a            # the constant\n\
float32 b            # coefficient of the first order\n\
float32 c            # coefficient of the second order\n\
float32 d            # coefficient of the third order\n\
float32 e            # coefficient of the fourth order\n\
float32 f            # coefficient of the fifth order\n\
float32 max_residual # the max differece from the fitted value and the true value\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::ld_msgs::EgoLineIndex_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.max_power_polynomial);
      stream.next(m.window_size);
      stream.next(m.is_ws_forward);
      stream.next(m.a);
      stream.next(m.b);
      stream.next(m.c);
      stream.next(m.d);
      stream.next(m.e);
      stream.next(m.f);
      stream.next(m.max_residual);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct EgoLineIndex_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::EgoLineIndex_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::EgoLineIndex_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "max_power_polynomial: ";
    Printer<int32_t>::stream(s, indent + "  ", v.max_power_polynomial);
    s << indent << "window_size: ";
    Printer<int32_t>::stream(s, indent + "  ", v.window_size);
    s << indent << "is_ws_forward: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.is_ws_forward);
    s << indent << "a: ";
    Printer<float>::stream(s, indent + "  ", v.a);
    s << indent << "b: ";
    Printer<float>::stream(s, indent + "  ", v.b);
    s << indent << "c: ";
    Printer<float>::stream(s, indent + "  ", v.c);
    s << indent << "d: ";
    Printer<float>::stream(s, indent + "  ", v.d);
    s << indent << "e: ";
    Printer<float>::stream(s, indent + "  ", v.e);
    s << indent << "f: ";
    Printer<float>::stream(s, indent + "  ", v.f);
    s << indent << "max_residual: ";
    Printer<float>::stream(s, indent + "  ", v.max_residual);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_EGOLINEINDEX_H
